<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'EndpointReferenceType' => '\\StructType\\EndpointReferenceType',
            'ReferenceParametersType' => '\\StructType\\ReferenceParametersType',
            'MetadataType' => '\\StructType\\MetadataType',
            'RelatesToType' => '\\StructType\\RelatesToType',
            'AttributedURIType' => '\\StructType\\AttributedURIType',
            'AttributedUnsignedLongType' => '\\StructType\\AttributedUnsignedLongType',
            'AttributedQNameType' => '\\StructType\\AttributedQNameType',
            'ProblemActionType' => '\\StructType\\ProblemActionType',
            'AttributedDateTime' => '\\StructType\\AttributedDateTime',
            'AttributedURI' => '\\StructType\\AttributedURI',
            'TimestampType' => '\\StructType\\TimestampType',
            'SignatureType' => '\\StructType\\SignatureType',
            'SignatureValueType' => '\\StructType\\SignatureValueType',
            'SignedInfoType' => '\\StructType\\SignedInfoType',
            'CanonicalizationMethodType' => '\\StructType\\CanonicalizationMethodType',
            'SignatureMethodType' => '\\StructType\\SignatureMethodType',
            'ReferenceType' => '\\StructType\\ReferenceType',
            'TransformsType' => '\\StructType\\TransformsType',
            'TransformType' => '\\StructType\\TransformType',
            'DigestMethodType' => '\\StructType\\DigestMethodType',
            'KeyInfoType' => '\\StructType\\KeyInfoType',
            'KeyValueType' => '\\StructType\\KeyValueType',
            'RetrievalMethodType' => '\\StructType\\RetrievalMethodType',
            'X509DataType' => '\\StructType\\X509DataType',
            'X509IssuerSerialType' => '\\StructType\\X509IssuerSerialType',
            'PGPDataType' => '\\StructType\\PGPDataType',
            'SPKIDataType' => '\\StructType\\SPKIDataType',
            'ObjectType' => '\\StructType\\ObjectType',
            'ManifestType' => '\\StructType\\ManifestType',
            'SignaturePropertiesType' => '\\StructType\\SignaturePropertiesType',
            'SignaturePropertyType' => '\\StructType\\SignaturePropertyType',
            'DSAKeyValueType' => '\\StructType\\DSAKeyValueType',
            'RSAKeyValueType' => '\\StructType\\RSAKeyValueType',
            'AttributedString' => '\\StructType\\AttributedString',
            'PasswordString' => '\\StructType\\PasswordString',
            'EncodedString' => '\\StructType\\EncodedString',
            'UsernameTokenType' => '\\StructType\\UsernameTokenType',
            'BinarySecurityTokenType' => '\\StructType\\BinarySecurityTokenType',
            'KeyIdentifierType' => '\\StructType\\KeyIdentifierType',
            'EmbeddedType' => '\\StructType\\EmbeddedType',
            'SecurityTokenReferenceType' => '\\StructType\\SecurityTokenReferenceType',
            'SecurityHeaderType' => '\\StructType\\SecurityHeaderType',
            'TransformationParametersType' => '\\StructType\\TransformationParametersType',
            'Code' => '\\StructType\\Code',
            'AnyType' => '\\StructType\\AnyType',
            'ReceiptRequestType' => '\\StructType\\ReceiptRequestType',
            'DeliveryAttributesType' => '\\StructType\\DeliveryAttributesType',
            'SecurityToken' => '\\StructType\\SecurityToken',
            'PartyType' => '\\StructType\\PartyType',
            'PartyIdentifierType' => '\\StructType\\PartyIdentifierType',
            'OriginatorsType' => '\\StructType\\OriginatorsType',
            'DestinationsType' => '\\StructType\\DestinationsType',
            'ProcessIdentifierType' => '\\StructType\\ProcessIdentifierType',
            'MsgIdentificationType' => '\\StructType\\MsgIdentificationType',
            'ProcessRef' => '\\StructType\\ProcessRef',
            'KeyCodeType' => '\\StructType\\KeyCodeType',
            'PropertyType' => '\\StructType\\PropertyType',
            'MessagePropertiesType' => '\\StructType\\MessagePropertiesType',
            'QualifierType' => '\\StructType\\QualifierType',
            'BusinessScenario' => '\\StructType\\BusinessScenario',
            'MessageType' => '\\StructType\\MessageType',
            'MessageProperties' => '\\StructType\\MessageProperties',
            'OtherDestinations' => '\\StructType\\OtherDestinations',
            'MessageMetaData' => '\\StructType\\MessageMetaData',
            'Policy' => '\\StructType\\Policy',
            'OperatorContentType' => '\\StructType\\OperatorContentType',
            'PolicyReference' => '\\StructType\\PolicyReference',
            'PolicyAttachment' => '\\StructType\\PolicyAttachment',
            'AppliesTo' => '\\StructType\\AppliesTo',
            'URI' => '\\StructType\\URI',
            'Envelope' => '\\StructType\\Envelope',
            'Header' => '\\StructType\\Header',
            'Body' => '\\StructType\\Body',
            'Fault' => '\\StructType\\Fault',
            'faultreason' => '\\StructType\\Faultreason',
            'reasontext' => '\\StructType\\Reasontext',
            'faultcode' => '\\StructType\\Faultcode',
            'subcode' => '\\StructType\\Subcode',
            'detail' => '\\StructType\\Detail',
            'NotUnderstoodType' => '\\StructType\\NotUnderstoodType',
            'SupportedEnvType' => '\\StructType\\SupportedEnvType',
            'UpgradeType' => '\\StructType\\UpgradeType',
            'TypeOfBusinessScenarioType' => '\\StructType\\TypeOfBusinessScenarioType',
            'MsgTimeStampsType' => '\\StructType\\MsgTimeStampsType',
            'MsgBoxRequestType' => '\\StructType\\MsgBoxRequestType',
            'MsgBoxResponseType' => '\\StructType\\MsgBoxResponseType',
            'NoMessageAvailable' => '\\StructType\\NoMessageAvailable',
            'MsgAttributeListType' => '\\StructType\\MsgAttributeListType',
            'MsgSelector' => '\\StructType\\MsgSelector',
            'MsgStatusListType' => '\\StructType\\MsgStatusListType',
            'MsgBoxFetchRequest' => '\\StructType\\MsgBoxFetchRequest',
            'MsgBoxStatusListRequestType' => '\\StructType\\MsgBoxStatusListRequestType',
            'MsgBoxGetNextRequestType' => '\\StructType\\MsgBoxGetNextRequestType',
            'MsgBoxCloseRequestType' => '\\StructType\\MsgBoxCloseRequestType',
            'ReceiptDemandType' => '\\StructType\\ReceiptDemandType',
            'ReceiptInfoType' => '\\StructType\\ReceiptInfoType',
            'DeliveryReceiptDemandType' => '\\StructType\\DeliveryReceiptDemandType',
            'ReceptionReceiptDemandType' => '\\StructType\\ReceptionReceiptDemandType',
            'DeliveryReceiptType' => '\\StructType\\DeliveryReceiptType',
            'ReceptionReceiptType' => '\\StructType\\ReceptionReceiptType',
            'FetchedNotificationDemandType' => '\\StructType\\FetchedNotificationDemandType',
            'FetchedNotificationType' => '\\StructType\\FetchedNotificationType',
            'X509TokenContainerType' => '\\StructType\\X509TokenContainerType',
            'X509TokenInfo' => '\\StructType\\X509TokenInfo',
            'TokenApplication' => '\\StructType\\TokenApplication',
            'X509CertificateAssertion' => '\\StructType\\X509CertificateAssertion',
            'QualTspAssertion' => '\\StructType\\QualTspAssertion',
            'ObsoleteAfterAssertion' => '\\StructType\\ObsoleteAfterAssertion',
            'AcceptedMsgLimits' => '\\StructType\\AcceptedMsgLimits',
            'MessageBody' => '\\StructType\\MessageBody',
            'AdditionalReportListType' => '\\StructType\\AdditionalReportListType',
            'Report' => '\\StructType\\Report',
            'Code.Fehlernummer' => '\\StructType\\Code_Fehlernummer',
            'Code.RecordType' => '\\StructType\\Code_RecordType',
            'Code.ReportType' => '\\StructType\\Code_ReportType',
            'Code.ServiceParameterType' => '\\StructType\\Code_ServiceParameterType',
            'ContentType' => '\\StructType\\ContentType',
            'IsServiceAvailableValueType' => '\\StructType\\IsServiceAvailableValueType',
            'LookupServiceResultType' => '\\StructType\\LookupServiceResultType',
            'ServiceParameter' => '\\StructType\\ServiceParameter',
            'LookupServiceType' => '\\StructType\\LookupServiceType',
            'MessageStatusType' => '\\StructType\\MessageStatusType',
            'ErrorList' => '\\StructType\\ErrorList',
            'WarnList' => '\\StructType\\WarnList',
            'InfoList' => '\\StructType\\InfoList',
            'RecordType' => '\\StructType\\RecordType',
            'EncryptedType' => '\\StructType\\EncryptedType',
            'EncryptionMethodType' => '\\StructType\\EncryptionMethodType',
            'CipherDataType' => '\\StructType\\CipherDataType',
            'CipherReferenceType' => '\\StructType\\CipherReferenceType',
            'EncryptedDataType' => '\\StructType\\EncryptedDataType',
            'EncryptedKeyType' => '\\StructType\\EncryptedKeyType',
            'AgreementMethodType' => '\\StructType\\AgreementMethodType',
            'ReferenceList' => '\\StructType\\ReferenceList',
            'EncryptionPropertiesType' => '\\StructType\\EncryptionPropertiesType',
            'EncryptionPropertyType' => '\\StructType\\EncryptionPropertyType',
            'DHKeyValueType' => '\\StructType\\DHKeyValueType',
            'GenericContentContainer' => '\\StructType\\GenericContentContainer',
            'ContentContainer' => '\\StructType\\ContentContainer',
            'LookupServiceRequest' => '\\StructType\\LookupServiceRequest',
            'LookupServiceRequestList' => '\\StructType\\LookupServiceRequestList',
            'LookupServiceResponse' => '\\StructType\\LookupServiceResponse',
            'LookupServiceResultList' => '\\StructType\\LookupServiceResultList',
            'TransportReport' => '\\StructType\\TransportReport',
            'CancelDeniedExceptionType' => '\\StructType\\CancelDeniedExceptionType',
            'ExceptionType' => '\\StructType\\ExceptionType',
            'InvalidMessageIDExceptionType' => '\\StructType\\InvalidMessageIDExceptionType',
            'MessageSchemaViolationExceptionType' => '\\StructType\\MessageSchemaViolationExceptionType',
            'MessageVirusDetectionExceptionType' => '\\StructType\\MessageVirusDetectionExceptionType',
            'ParameterIsNotValidExceptionType' => '\\StructType\\ParameterIsNotValidExceptionType',
            'PermissionDeniedExceptionType' => '\\StructType\\PermissionDeniedExceptionType',
            'SyncAsyncExceptionType' => '\\StructType\\SyncAsyncExceptionType',
            'XTAWSTechnicalProblemExceptionType' => '\\StructType\\XTAWSTechnicalProblemExceptionType',
        );
    }
}
