<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DHKeyValueType StructType
 * @subpackage Structs
 */
class DHKeyValueType extends AbstractStructBase
{
    /**
     * The P
     * Meta information extracted from the WSDL
     * - base: base64Binary
     * @var string
     */
    public $P;
    /**
     * The Q
     * Meta information extracted from the WSDL
     * - base: base64Binary
     * @var string
     */
    public $Q;
    /**
     * The Generator
     * Meta information extracted from the WSDL
     * - base: base64Binary
     * @var string
     */
    public $Generator;
    /**
     * The Public
     * Meta information extracted from the WSDL
     * - base: base64Binary
     * @var string
     */
    public $Public;
    /**
     * The seed
     * Meta information extracted from the WSDL
     * - base: base64Binary
     * @var string
     */
    public $seed;
    /**
     * The pgenCounter
     * Meta information extracted from the WSDL
     * - base: base64Binary
     * @var string
     */
    public $pgenCounter;
    /**
     * Constructor method for DHKeyValueType
     * @uses DHKeyValueType::setP()
     * @uses DHKeyValueType::setQ()
     * @uses DHKeyValueType::setGenerator()
     * @uses DHKeyValueType::setPublic()
     * @uses DHKeyValueType::setSeed()
     * @uses DHKeyValueType::setPgenCounter()
     * @param string $p
     * @param string $q
     * @param string $generator
     * @param string $public
     * @param string $seed
     * @param string $pgenCounter
     */
    public function __construct($p = null, $q = null, $generator = null, $public = null, $seed = null, $pgenCounter = null)
    {
        $this
            ->setP($p)
            ->setQ($q)
            ->setGenerator($generator)
            ->setPublic($public)
            ->setSeed($seed)
            ->setPgenCounter($pgenCounter);
    }
    /**
     * Get P value
     * @return string|null
     */
    public function getP()
    {
        return $this->P;
    }
    /**
     * Set P value
     * @param string $p
     * @return \StructType\DHKeyValueType
     */
    public function setP($p = null)
    {
        // validation for constraint: string
        if (!is_null($p) && !is_string($p)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($p, true), gettype($p)), __LINE__);
        }
        $this->P = $p;
        return $this;
    }
    /**
     * Get Q value
     * @return string|null
     */
    public function getQ()
    {
        return $this->Q;
    }
    /**
     * Set Q value
     * @param string $q
     * @return \StructType\DHKeyValueType
     */
    public function setQ($q = null)
    {
        // validation for constraint: string
        if (!is_null($q) && !is_string($q)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($q, true), gettype($q)), __LINE__);
        }
        $this->Q = $q;
        return $this;
    }
    /**
     * Get Generator value
     * @return string|null
     */
    public function getGenerator()
    {
        return $this->Generator;
    }
    /**
     * Set Generator value
     * @param string $generator
     * @return \StructType\DHKeyValueType
     */
    public function setGenerator($generator = null)
    {
        // validation for constraint: string
        if (!is_null($generator) && !is_string($generator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($generator, true), gettype($generator)), __LINE__);
        }
        $this->Generator = $generator;
        return $this;
    }
    /**
     * Get Public value
     * @return string|null
     */
    public function getPublic()
    {
        return $this->Public;
    }
    /**
     * Set Public value
     * @param string $public
     * @return \StructType\DHKeyValueType
     */
    public function setPublic($public = null)
    {
        // validation for constraint: string
        if (!is_null($public) && !is_string($public)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($public, true), gettype($public)), __LINE__);
        }
        $this->Public = $public;
        return $this;
    }
    /**
     * Get seed value
     * @return string|null
     */
    public function getSeed()
    {
        return $this->seed;
    }
    /**
     * Set seed value
     * @param string $seed
     * @return \StructType\DHKeyValueType
     */
    public function setSeed($seed = null)
    {
        // validation for constraint: string
        if (!is_null($seed) && !is_string($seed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($seed, true), gettype($seed)), __LINE__);
        }
        $this->seed = $seed;
        return $this;
    }
    /**
     * Get pgenCounter value
     * @return string|null
     */
    public function getPgenCounter()
    {
        return $this->pgenCounter;
    }
    /**
     * Set pgenCounter value
     * @param string $pgenCounter
     * @return \StructType\DHKeyValueType
     */
    public function setPgenCounter($pgenCounter = null)
    {
        // validation for constraint: string
        if (!is_null($pgenCounter) && !is_string($pgenCounter)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pgenCounter, true), gettype($pgenCounter)), __LINE__);
        }
        $this->pgenCounter = $pgenCounter;
        return $this;
    }
}
