<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Envelope StructType
 * Meta information extracted from the WSDL
 * - type: tns:Envelope
 * @subpackage Structs
 */
class Envelope extends AbstractStructBase
{
    /**
     * The Header
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: tns:Header
     * @var \StructType\Header
     */
    public $Header;
    /**
     * The Body
     * Meta information extracted from the WSDL
     * - ref: tns:Body
     * @var \StructType\Body
     */
    public $Body;
    /**
     * Constructor method for Envelope
     * @uses Envelope::setHeader()
     * @uses Envelope::setBody()
     * @param \StructType\Header $header
     * @param \StructType\Body $body
     */
    public function __construct(\StructType\Header $header = null, \StructType\Body $body = null)
    {
        $this
            ->setHeader($header)
            ->setBody($body);
    }
    /**
     * Get Header value
     * @return \StructType\Header|null
     */
    public function getHeader()
    {
        return $this->Header;
    }
    /**
     * Set Header value
     * @param \StructType\Header $header
     * @return \StructType\Envelope
     */
    public function setHeader(\StructType\Header $header = null)
    {
        $this->Header = $header;
        return $this;
    }
    /**
     * Get Body value
     * @return \StructType\Body|null
     */
    public function getBody()
    {
        return $this->Body;
    }
    /**
     * Set Body value
     * @param \StructType\Body $body
     * @return \StructType\Envelope
     */
    public function setBody(\StructType\Body $body = null)
    {
        $this->Body = $body;
        return $this;
    }
}
