<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for faultreason StructType
 * @subpackage Structs
 */
class Faultreason extends AbstractStructBase
{
    /**
     * The Text
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Reasontext[]
     */
    public $Text;
    /**
     * Constructor method for faultreason
     * @uses Faultreason::setText()
     * @param \StructType\Reasontext[] $text
     */
    public function __construct(array $text = array())
    {
        $this
            ->setText($text);
    }
    /**
     * Get Text value
     * @return \StructType\Reasontext[]|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * This method is responsible for validating the values passed to the setText method
     * This method is willingly generated in order to preserve the one-line inline validation within the setText method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTextForArrayConstraintsFromSetText(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $faultreasonTextItem) {
            // validation for constraint: itemType
            if (!$faultreasonTextItem instanceof \StructType\Reasontext) {
                $invalidValues[] = is_object($faultreasonTextItem) ? get_class($faultreasonTextItem) : sprintf('%s(%s)', gettype($faultreasonTextItem), var_export($faultreasonTextItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Text property can only contain items of type \StructType\Reasontext, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Text value
     * @throws \InvalidArgumentException
     * @param \StructType\Reasontext[] $text
     * @return \StructType\Faultreason
     */
    public function setText(array $text = array())
    {
        // validation for constraint: array
        if ('' !== ($textArrayErrorMessage = self::validateTextForArrayConstraintsFromSetText($text))) {
            throw new \InvalidArgumentException($textArrayErrorMessage, __LINE__);
        }
        $this->Text = $text;
        return $this;
    }
    /**
     * Add item to Text value
     * @throws \InvalidArgumentException
     * @param \StructType\Reasontext $item
     * @return \StructType\Faultreason
     */
    public function addToText(\StructType\Reasontext $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Reasontext) {
            throw new \InvalidArgumentException(sprintf('The Text property can only contain items of type \StructType\Reasontext, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Text[] = $item;
        return $this;
    }
}
