<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LookupServiceRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Dies ist eine Liste von Dienstanfragen.Jede Anfrage dient dazu, zu ermitteln, ob der Dienst von diesem Anbieter angeboten wird, und über welche technischen Parameter er angesprochen werden kann.
 * @subpackage Structs
 */
class LookupServiceRequest extends AbstractStructBase
{
    /**
     * The LookupServiceRequestList
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\LookupServiceRequestList[]
     */
    public $LookupServiceRequestList;
    /**
     * Constructor method for LookupServiceRequest
     * @uses LookupServiceRequest::setLookupServiceRequestList()
     * @param \StructType\LookupServiceRequestList[] $lookupServiceRequestList
     */
    public function __construct(array $lookupServiceRequestList = array())
    {
        $this
            ->setLookupServiceRequestList($lookupServiceRequestList);
    }
    /**
     * Get LookupServiceRequestList value
     * @return \StructType\LookupServiceRequestList[]|null
     */
    public function getLookupServiceRequestList()
    {
        return $this->LookupServiceRequestList;
    }
    /**
     * This method is responsible for validating the values passed to the setLookupServiceRequestList method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLookupServiceRequestList method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLookupServiceRequestListForArrayConstraintsFromSetLookupServiceRequestList(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $lookupServiceRequestLookupServiceRequestListItem) {
            // validation for constraint: itemType
            if (!$lookupServiceRequestLookupServiceRequestListItem instanceof \StructType\LookupServiceRequestList) {
                $invalidValues[] = is_object($lookupServiceRequestLookupServiceRequestListItem) ? get_class($lookupServiceRequestLookupServiceRequestListItem) : sprintf('%s(%s)', gettype($lookupServiceRequestLookupServiceRequestListItem), var_export($lookupServiceRequestLookupServiceRequestListItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The LookupServiceRequestList property can only contain items of type \StructType\LookupServiceRequestList, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set LookupServiceRequestList value
     * @throws \InvalidArgumentException
     * @param \StructType\LookupServiceRequestList[] $lookupServiceRequestList
     * @return \StructType\LookupServiceRequest
     */
    public function setLookupServiceRequestList(array $lookupServiceRequestList = array())
    {
        // validation for constraint: array
        if ('' !== ($lookupServiceRequestListArrayErrorMessage = self::validateLookupServiceRequestListForArrayConstraintsFromSetLookupServiceRequestList($lookupServiceRequestList))) {
            throw new \InvalidArgumentException($lookupServiceRequestListArrayErrorMessage, __LINE__);
        }
        $this->LookupServiceRequestList = $lookupServiceRequestList;
        return $this;
    }
    /**
     * Add item to LookupServiceRequestList value
     * @throws \InvalidArgumentException
     * @param \StructType\LookupServiceRequestList $item
     * @return \StructType\LookupServiceRequest
     */
    public function addToLookupServiceRequestList(\StructType\LookupServiceRequestList $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LookupServiceRequestList) {
            throw new \InvalidArgumentException(sprintf('The LookupServiceRequestList property can only contain items of type \StructType\LookupServiceRequestList, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->LookupServiceRequestList[] = $item;
        return $this;
    }
}
