<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LookupServiceRequestList StructType
 * Meta information extracted from the WSDL
 * - documentation: Dies ist die Struktur für eine Liste von Dienstanfragen.
 * @subpackage Structs
 */
class LookupServiceRequestList extends AbstractStructBase
{
    /**
     * The LookupService
     * Meta information extracted from the WSDL
     * - documentation: Dies ist eine Service-Anfrage. Sie enthält Daten zum potentiellen Diensteanbieter (Leser) und dem Dienst, der angefragt werden soll. Diese Anfrage dient dazu, zu ermitteln, ob der Dienst von diesem Anbieter angeboten wird, und über
     * welche technischen Parameter er angesprochen werden kann.
     * @var \StructType\LookupServiceType
     */
    public $LookupService;
    /**
     * Constructor method for LookupServiceRequestList
     * @uses LookupServiceRequestList::setLookupService()
     * @param \StructType\LookupServiceType $lookupService
     */
    public function __construct(\StructType\LookupServiceType $lookupService = null)
    {
        $this
            ->setLookupService($lookupService);
    }
    /**
     * Get LookupService value
     * @return \StructType\LookupServiceType|null
     */
    public function getLookupService()
    {
        return $this->LookupService;
    }
    /**
     * Set LookupService value
     * @param \StructType\LookupServiceType $lookupService
     * @return \StructType\LookupServiceRequestList
     */
    public function setLookupService(\StructType\LookupServiceType $lookupService = null)
    {
        $this->LookupService = $lookupService;
        return $this;
    }
}
