<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OriginatorsType StructType
 * @subpackage Structs
 */
class OriginatorsType extends AbstractStructBase
{
    /**
     * The Author
     * Meta information extracted from the WSDL
     * - ref: oscimeta:Author
     * @var \StructType\PartyType
     */
    public $Author;
    /**
     * The Sender
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: oscimeta:Sender
     * @var \StructType\PartyType
     */
    public $Sender;
    /**
     * The ReplyTo
     * Meta information extracted from the WSDL
     * - documentation: If response expected different from value outlined in "From" address
     * - minOccurs: 0
     * @var \StructType\PartyType
     */
    public $ReplyTo;
    /**
     * Constructor method for OriginatorsType
     * @uses OriginatorsType::setAuthor()
     * @uses OriginatorsType::setSender()
     * @uses OriginatorsType::setReplyTo()
     * @param \StructType\PartyType $author
     * @param \StructType\PartyType $sender
     * @param \StructType\PartyType $replyTo
     */
    public function __construct(\StructType\PartyType $author = null, \StructType\PartyType $sender = null, \StructType\PartyType $replyTo = null)
    {
        $this
            ->setAuthor($author)
            ->setSender($sender)
            ->setReplyTo($replyTo);
    }
    /**
     * Get Author value
     * @return \StructType\PartyType|null
     */
    public function getAuthor()
    {
        return $this->Author;
    }
    /**
     * Set Author value
     * @param \StructType\PartyType $author
     * @return \StructType\OriginatorsType
     */
    public function setAuthor(\StructType\PartyType $author = null)
    {
        $this->Author = $author;
        return $this;
    }
    /**
     * Get Sender value
     * @return \StructType\PartyType|null
     */
    public function getSender()
    {
        return $this->Sender;
    }
    /**
     * Set Sender value
     * @param \StructType\PartyType $sender
     * @return \StructType\OriginatorsType
     */
    public function setSender(\StructType\PartyType $sender = null)
    {
        $this->Sender = $sender;
        return $this;
    }
    /**
     * Get ReplyTo value
     * @return \StructType\PartyType|null
     */
    public function getReplyTo()
    {
        return $this->ReplyTo;
    }
    /**
     * Set ReplyTo value
     * @param \StructType\PartyType $replyTo
     * @return \StructType\OriginatorsType
     */
    public function setReplyTo(\StructType\PartyType $replyTo = null)
    {
        $this->ReplyTo = $replyTo;
        return $this;
    }
}
