<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReceptionReceiptType StructType
 * @subpackage Structs
 */
class ReceptionReceiptType extends AbstractStructBase
{
    /**
     * The ReceiptInfo
     * Meta information extracted from the WSDL
     * - ref: osci:ReceiptInfo
     * @var \StructType\ReceiptInfoType
     */
    public $ReceiptInfo;
    /**
     * The Signature
     * Meta information extracted from the WSDL
     * - ref: ds:Signature
     * @var \StructType\SignatureType
     */
    public $Signature;
    /**
     * Constructor method for ReceptionReceiptType
     * @uses ReceptionReceiptType::setReceiptInfo()
     * @uses ReceptionReceiptType::setSignature()
     * @param \StructType\ReceiptInfoType $receiptInfo
     * @param \StructType\SignatureType $signature
     */
    public function __construct(\StructType\ReceiptInfoType $receiptInfo = null, \StructType\SignatureType $signature = null)
    {
        $this
            ->setReceiptInfo($receiptInfo)
            ->setSignature($signature);
    }
    /**
     * Get ReceiptInfo value
     * @return \StructType\ReceiptInfoType|null
     */
    public function getReceiptInfo()
    {
        return $this->ReceiptInfo;
    }
    /**
     * Set ReceiptInfo value
     * @param \StructType\ReceiptInfoType $receiptInfo
     * @return \StructType\ReceptionReceiptType
     */
    public function setReceiptInfo(\StructType\ReceiptInfoType $receiptInfo = null)
    {
        $this->ReceiptInfo = $receiptInfo;
        return $this;
    }
    /**
     * Get Signature value
     * @return \StructType\SignatureType|null
     */
    public function getSignature()
    {
        return $this->Signature;
    }
    /**
     * Set Signature value
     * @param \StructType\SignatureType $signature
     * @return \StructType\ReceptionReceiptType
     */
    public function setSignature(\StructType\SignatureType $signature = null)
    {
        $this->Signature = $signature;
        return $this;
    }
}
