<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpgradeType StructType
 * @subpackage Structs
 */
class UpgradeType extends AbstractStructBase
{
    /**
     * The SupportedEnvelope
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\SupportedEnvType[]
     */
    public $SupportedEnvelope;
    /**
     * Constructor method for UpgradeType
     * @uses UpgradeType::setSupportedEnvelope()
     * @param \StructType\SupportedEnvType[] $supportedEnvelope
     */
    public function __construct(array $supportedEnvelope = array())
    {
        $this
            ->setSupportedEnvelope($supportedEnvelope);
    }
    /**
     * Get SupportedEnvelope value
     * @return \StructType\SupportedEnvType[]|null
     */
    public function getSupportedEnvelope()
    {
        return $this->SupportedEnvelope;
    }
    /**
     * This method is responsible for validating the values passed to the setSupportedEnvelope method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupportedEnvelope method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupportedEnvelopeForArrayConstraintsFromSetSupportedEnvelope(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $upgradeTypeSupportedEnvelopeItem) {
            // validation for constraint: itemType
            if (!$upgradeTypeSupportedEnvelopeItem instanceof \StructType\SupportedEnvType) {
                $invalidValues[] = is_object($upgradeTypeSupportedEnvelopeItem) ? get_class($upgradeTypeSupportedEnvelopeItem) : sprintf('%s(%s)', gettype($upgradeTypeSupportedEnvelopeItem), var_export($upgradeTypeSupportedEnvelopeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SupportedEnvelope property can only contain items of type \StructType\SupportedEnvType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SupportedEnvelope value
     * @throws \InvalidArgumentException
     * @param \StructType\SupportedEnvType[] $supportedEnvelope
     * @return \StructType\UpgradeType
     */
    public function setSupportedEnvelope(array $supportedEnvelope = array())
    {
        // validation for constraint: array
        if ('' !== ($supportedEnvelopeArrayErrorMessage = self::validateSupportedEnvelopeForArrayConstraintsFromSetSupportedEnvelope($supportedEnvelope))) {
            throw new \InvalidArgumentException($supportedEnvelopeArrayErrorMessage, __LINE__);
        }
        $this->SupportedEnvelope = $supportedEnvelope;
        return $this;
    }
    /**
     * Add item to SupportedEnvelope value
     * @throws \InvalidArgumentException
     * @param \StructType\SupportedEnvType $item
     * @return \StructType\UpgradeType
     */
    public function addToSupportedEnvelope(\StructType\SupportedEnvType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SupportedEnvType) {
            throw new \InvalidArgumentException(sprintf('The SupportedEnvelope property can only contain items of type \StructType\SupportedEnvType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SupportedEnvelope[] = $item;
        return $this;
    }
}
